unit UFPuntuales;

interface
uses
  XComun;
  
procedure XFP_Neg(const M1: XMat; var M2 : XMat);
procedure XFP_Gris(const M1: XMat; var M2 : XMat);

implementation

procedure XFP_Neg(const M1: XMat; var M2 : XMat);
var
  x,y,k : integer;
begin
  M2.nc := M1.nc;
  M2.nr := M1.nr;
  SetLength(M2.dat,M2.nc,M2.nr,3);

  for k := 0 to 2 do
    for y := 0 to M1.nr - 1 do
      for x := 0 to M1.nc - 1 do
        M2.dat[x][y][k] := _Lambda - M1.dat[x][y][k];

end;

procedure XFP_Gris(const M1: XMat; var M2 : XMat);
var
  x,y,k : integer;
  sum   : single;
begin
  M2.nc := M1.nc;
  M2.nr := M1.nr;
  SetLength(M2.dat,M2.nc,M2.nr,3);

  for y := 0 to M1.nr - 1 do
    for x := 0 to M1.nc - 1 do begin
      sum := 0.0;
      for k := 0 to 2 do sum := sum + M1.dat[x][y][k];
      sum := sum/3;
      for k := 0 to 2 do M2.dat[x][y][k] := sum;
    end;

end;

end.
